<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_contentFilter_date_range extends JPlugin
{
	var $_error = true;

	function plgJoomsuite_contentFilter_date_range( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onFilterWhere(&$where, $filter, $prm, $category)
	{
		global $mainframe, $option;

		if($filter->type != 'date_range') return;
		$vals = $this->check_mode($filter);
		$from = $vals['from_flat'];
		$to = $vals['to_flat'];

		if(!$from && !$to)
		{
			return;
		}
		
		$fparams = $filter->exec_params;
		$filter_by = $fparams->get('filter_by', 'ctime');
		
		if ($filter_by == 'cal'){
			$fid = $fparams->get('cal_field');
			if ($from && $to){
				$where[] = "r.id IN (SELECT record_id FROM #__js_res_record_values WHERE field_id = {$fid} AND field_value >= '$from 00:00:00' AND field_value <= '$to 23:59:59')";
			}
			else if ($from && !$to){
				$where[] = "r.id IN (SELECT record_id FROM #__js_res_record_values WHERE field_id = {$fid} AND field_value >= '$from 00:00:00')";
			}
			else if (!$from && $to){
				$where[] = "r.id IN (SELECT record_id FROM #__js_res_record_values WHERE field_id = {$fid} AND field_value <= '$to 23:59:59')";
			}
		}
		else {
			if ($from && $to){
				$where[] = "(r.{$filter_by} >= '$from 00:00:00' AND r.{$filter_by} <= '$to 23:59:59')";
			}
			else if ($from && !$to){
				$where[] = "(r.{$filter_by} >= '$from 00:00:00')";
			}
			else if (!$from && $to){
				$where[] = "(r.{$filter_by} <= '$to 23:59:59')";
			}
		}
	}
	
	function onFilterLeftJoin(&$query, $filter, $params, $category)
	{
	}
	
	function onFilterWorn(&$out, $filter, $prm, $category)
	{
		if($filter->type != 'date_range') return;
		$vals = $this->check_mode($filter);
		$from = $vals['from_flat'];
		$to = $vals['to_flat'];
		if ($from && $to) 		$str =  JText::_('From:').' %s '.JText::_('Till:').' %s';
		else if ($from && !$to) $str =  JText::_('From:').' %s%s';
		else if (!$from && $to) $str =  JText::_('Till:').' %s%s';
		else return;
		$str = sprintf($str, $from, $to);
		$out = $str;
	}
	function onFilterRender(&$out, $filter, $category, $prm)
	{
		if($filter->type != 'date_range') return;

		$vals = $this->check_mode($filter);
		$from = $vals['from'];
		$to = $vals['to'];
		$fparams = $filter->exec_params;
		$fid = 'ext_filter'.$filter->id;
		$fname = $fid.'[]';

		//Hidden field needs for not reset other values if first one is zero, fix for custom enter data

		switch ($fparams->get('input_type')){
			case 'input':
				$hidden = "<input type='hidden' id='{$fid}_hid' name='$fname' value='custom'/>";
				//$from = JHTML::_('calendar', $from[0], $fname, $fid.'_from');
				$from = "<input type=\"text\" name=\"$fname\" id=\"{$fid}_from\" value=\"{$from[0]}\" />
				<img class=\"calendar\" src=\"".JURI::root()."templates/system/images/calendar.png\" alt=\"calendar\" id=\"{$fid}_frompop\" />";
				$from .= "<script type=\"text/javascript\">
						        Calendar.setup(
						          {
						            inputField  : \"{$fid}_from\",         // ID of the input field
						            ifFormat    : \"%Y-%m-%d\",    // the date format
						            button      : \"{$fid}_frompop\"       // ID of the button
						          }
						        );
						</script><style>div.calendar{z-index:66000;}</style>";
				
				//$to = JHTML::_('calendar', $to[0], $fname, $fid.'_to');
				$to = "<input type=\"text\" name=\"$fname\" id=\"{$fid}_to\" value=\"{$to[0]}\" />
				<img class=\"calendar\" src=\"".JURI::root()."templates/system/images/calendar.png\" alt=\"calendar\" id=\"{$fid}_topop\" />";
				$to .= "<script type=\"text/javascript\">
						        Calendar.setup(
						          {
						            inputField  : \"{$fid}_to\",         // ID of the input field
						            ifFormat    : \"%Y-%m-%d\",    // the date format
						            button      : \"{$fid}_topop\"       // ID of the button
						          }
						        );
						</script>";
				JHTML::_('behavior.calendar');
				$output = sprintf('%s %s %s %s %s' ,$hidden, JText::_('From:'), $from, JText::_('Till:'), $to);
				break;
			case 'select':
				
		//Organize Cycles for years/months/days custom select lists//
	   ////////////////////////////////////////////////////////////
	   			function getyear($yeas)
	   			{
	   				$yeas = explode('-', $yeas);
	   				return $yeas[0];
	   			}
				$custom_from = getyear($fparams->get('custom_from'));
				$custom_to = getyear($fparams->get('custom_to'));
				$yincr = $custom_from;
				$jm = $fparams->get('jump_mod');
				$hidden = "<input type='hidden' id='{$fid}_hid' name='$fname' value='".$jm."'/>";

				if ($jm){
					//jump years
					$jump_y[] = JHTML::_('select.option', null, JText::_('-year-'));
					for ($y = $custom_from; $y <= $custom_to; $y++){
						$jump_y[] = JHTML::_('select.option', $y, $y);
					}
					//jump month
					$jump_m[] = JHTML::_('select.option', null, JText::_('-month-'));
					for ($m = 1; $m < 13; $m++){
						$jump_m[] = JHTML::_('select.option', $m, $m);
					}
					//jump days
					$jump_d[] = JHTML::_('select.option', null, JText::_('-day-'));
					for ($d = 1; $d < 32; $d++){
						$jump_d[] = JHTML::_('select.option', $d, $d);
					}
					//block from
					$sjump_y = JHTML::_('select.genericlist', $jump_y, $fname, 'class="inputbox"', 'value', 'text', @$from[0]);
					$sjump_m = JHTML::_('select.genericlist', $jump_m, $fname, 'class="inputbox"', 'value', 'text', @$from[1]);
					$sjump_d = JHTML::_('select.genericlist', $jump_d, $fname, 'class="inputbox"', 'value', 'text', @$from[2]);
					$block_from = '<span class="jump_block">'.$sjump_y.$sjump_m.$sjump_d.'</ span>';
					//block to
					$sjump_y = JHTML::_('select.genericlist', $jump_y, $fname, 'class="inputbox"', 'value', 'text', @$to[0]);
					$sjump_m = JHTML::_('select.genericlist', $jump_m, $fname, 'class="inputbox"', 'value', 'text', @$to[1]);
					$sjump_d = JHTML::_('select.genericlist', $jump_d, $fname, 'class="inputbox"', 'value', 'text', @$to[2]);
					$block_to = '<span class="jump_block">'.$sjump_y.$sjump_m.$sjump_d.'</ span>';
						
					$output = $hidden.JText::_('From:').$block_from.JText::_('Till:').$block_to;
				}
				else{
					//Cycle years only
					while ($custom_to >= $yincr){
						//jump only years
						$value = $yincr.'-01-01';
						$text = $yincr.'-01-01';
						$custom_fselect[] = JHTML::_('select.option', $value, $text);
						$value = $yincr.'-12-31';
						$text = $yincr.'-12-31';
						$custom_tselect[] = JHTML::_('select.option', $value, $text);
						$yincr++;
					}
					$from = JHTML::_('select.genericlist', $custom_fselect, $fname, 'class="inputbox"', 'value', 'text', $from);
					$to = JHTML::_('select.genericlist', $custom_tselect, $fname, 'class="inputbox"', 'value', 'text', $to);

					$output = $hidden.JText::_('From:').$from.JText::_('Till:').$to;
				}
				break;
		}
		
		$out = $output;
	}

	function check_mode($filter) {
		$mode = @$filter->default[0];
		if ($mode == 'custom' || $mode == 0){
			$from[] = @$filter->default[1];
			$to[] = @$filter->default[2];
			if (($from > $to) && $from && $to){
				$from = $filter->default[2];
				$to = $filter->default[1];
				$filter->default[1] = $from;
				$filter->default[2] = $to;
				JError::raiseNotice(100, $filter->title.': '.Jtext::_('\'From\' was greater than \'Till\', values shifted!'));
			}
			$from_flat = $from[0];
			$to_flat = $to[0];
		}
		else if ($mode == 1){
			$from[] = @$filter->default[1];
			$from[] = @$filter->default[2];
			$from[] = @$filter->default[3];
			$to[] = @$filter->default[4];
			$to[] = @$filter->default[5];
			$to[] = @$filter->default[6];
			//@todo check if value from is greater than to exit and warning
			$from_flat = $from[0] ? $from[0] : null;
			$from_flat .= $from[0] ? $from[1] ? '-'.$from[1] : '-01' : null;
			$from_flat .= $from[0] ? $from[2] ? '-'.$from[2] : '-01' :  null;
				
			$to_flat = $to[0] ? $to[0] : null;
			$to_flat .= $to[0] ? $to[1] ? '-'.$to[1] : '-12' : null;
			$to_flat .= $to[0] ? $to[2] ? '-'.$to[2] : '-31' :  null;

		}

		return array ('mode'=>$mode, 'from'=>$from, 'to'=>$to, 'from_flat'=>$from_flat, 'to_flat'=>$to_flat);
	}
}