<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

$document = &JFactory::getDocument();
$document->addScript( JURI::root().'media/mightyextensions/xajax/xajax_js/xajax_core.js' );

class plgJoomsuite_contentFilter_kladr extends JPlugin
{
	function plgJoomsuite_contentFilter_kladr( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onFilterWhere( &$where, $filter, $prm, $category )
	{
		if( $filter->type != 'kladr' ) return;

		$fparams = & $filter->exec_params;

	    if( $filter->exec_params->get( 'ext_filter_view' ) == 'select' ) {
            $chains = isset( $filter->default ) ? array( implode( '\n', $this->prepareLines( $filter->default ) ) ) : array();
        } else {
        	$chains = isset( $filter->default ) ? $filter->default : array();
        }
        
		$condition = array();

		$f_alias = " CONCAT( ev".$fparams->get('ext_filter_field').".value, \"\\\n\" ) ";

		foreach( $chains as $chain ) {
			$condition[] = $f_alias.' like "'.$chain.'%"';
		}

		if($filter->default) $where[] = implode( " OR ", $condition );
	}

	function onFilterLeftJoin( &$query, $filter, $params, $category )
	{
		if($filter->type != 'kladr') return;

		$fparams = $filter->exec_params;

		if($filter->default) {
			$query[] = " LEFT JOIN #__js_res_field_extra AS ev".$fparams->get('ext_filter_field')." ON ev".$fparams->get('ext_filter_field').".record_id = v.record_id AND ev".$fparams->get('ext_filter_field').".field_id = ".$fparams->get('ext_filter_field');
		}
	}

	function onFilterWorn( &$out, $filter, $prm, $category )
	{
		if( $filter->type != 'kladr' ) return;

//		$db = JFactory::getDBO();
//        
//        $db->setQuery( "SELECT params FROM #__js_res_filters WHERE id = ".$filter->id );
//        $filter_ini_params = $db->loadResult();
//
//        $filter_params = new JParameter( $filter_ini_params );
//
//        $db->setQuery( "SELECT params FROM #__js_res_fields WHERE id = ".$filter_params->get( 'ext_filter_field' ) );
//        $field_ini_params = $db->loadResult();
//         
//        $params = new JParameter( $field_ini_params );
		
		$fragments = array();
		
//	    if( $filter->exec_params->get( 'ext_filter_view' ) == 'select' ) {
//            $chains = isset( $filter->default ) ? array( implode( "\n", $this->prepareLines( $filter->default ) ) ) : array();
//        } else {
            $chains = isset( $filter->default ) ? $filter->default : array();
//        }
        
        
	
        $res_values = array();
	        
        foreach( $chains as $key => $value ) {
            $separator = ( $key > 0 ? " " : "" );
	            
            $fragments[] = $separator.$value;

            //$fragments[] = implode( "", $res_values );
        }

		$out = "'".implode( "' ".$filter->exec_params->get('ext_filter_worn_separator')." '", $fragments )."'";
	}

	function onFilterRender( &$out, $filter, $category, $prm )
	{

		if($filter->type != 'kladr') return;
		
		if(!$filter->exec_params->get('ext_filter_field'))
		{
			JError::raiseWarning(100, JText::_('The field is not set in the extended filter "select relate"'));
			return;	
		}
		
//		if( $filter->exec_params->get( 'ext_filter_view' ) == 'select' ) {
//			$this->renderSelectView( $out, $filter, $category, $prm );
//			return;
//		}

		$db = JFactory::getDBO();

		$db->setQuery( "SELECT params FROM #__js_res_fields where id = ".$filter->exec_params->get( 'ext_filter_field' ) );
		$ini_params = $db->loadResult();
	  
		$params = new JParameter( $ini_params );
	  
		$filters_mode = $prm->get( 'filters_mode', 1 );
	  
		$exists_values = $this->getExistingsValues( $filters_mode, $filter->exec_params->get( 'ext_filter_field' ), $category );
	  
		$selected_values = isset( $filter->default ) ? $filter->default : array() ;
//		foreach( $selected_values as $key => $selected_value ) {
//			$selected_values[$key] = str_replace( "\r", "", $selected_value );
//		}
	  
		$result = $this->renderThemAll(  $selected_values, $filter->id, $exists_values );
	  	$out = $result[1];
		$out .=  "<script type='text/javascript'>
	                function jsfilter".$filter->id."_expand( div_id, imgspan_id, value ) {
	                  $(div_id).setStyles({height:'auto'});
						
				      var imgspan = document.getElementById( imgspan_id );
	                  
	                  var event = 'jsfilter".$filter->id."_collapse( \''+div_id+'\', \''+imgspan_id+'\' )';
	                  
	                  imgspan.innerHTML = '<img style=\"cursor: pointer;\" src=\"".JURI::root()."plugins/joomsuite_content/images/filter_kladr/expanded.png\" onclick = \"'+event+'\" >';
	                  
	                }
	                
	                function jsfilter".$filter->id."_collapse( div_id, imgspan_id, checkbox_id ) {
	                  $(div_id).setStyles({height:0});
	                  var imgspan = document.getElementById( imgspan_id );
	                  
	                  var event = 'jsfilter".$filter->id."_expand( \''+div_id+'\', \''+imgspan_id+'\' )';
	                  
	                  imgspan.innerHTML = '<img style=\"cursor: pointer;\" src=\"".JURI::root()."plugins/joomsuite_content/images/filter_kladr/collapsed.png\" onclick = \"'+event+'\" >';
	                } 
	              </script>";
	}

    
	function getExistingsValues( $filters_mode, $filter_field_id, $category )
	{
		$db = JFactory::getDBO();

		$where = "AND r.published = 1
		         AND (r.extime = '0000-00-00 00:00:00' OR r.extime > NOW())
		         AND r.ctime <= NOW()
		         AND r.client = 'resource'";
	  
		switch ( $filters_mode ) {
			case 1:
				$sql = "    SELECT fe.ref_id AS value,fe.value as text, COUNT( r.id ) as total , SUBSTRING_INDEX(fe.ref_id, '_', -1) as code"
	                           
				."\n      FROM #__js_res_field_extra AS fe
					 LEFT JOIN #__js_res_record AS r ON r.id = fe.record_id"
				."\n LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fe.record_id"
	            
				."\n     WHERE fe.field_id = ".$filter_field_id."
                         AND rc.catid = {$category} {$where}
				 		 AND fe.ref_id != 'index'"
				."\n  GROUP BY fe.value"
				."\n  ORDER by code,text";
				break;
			case 2:
				$sql = "  SELECT fe.ref_id AS value,fe.value as text, COUNT( r.id ) as total , SUBSTRING_INDEX(fe.ref_id, '_', -1) as code
						FROM #__js_res_field_extra AS fe
					LEFT JOIN #__js_res_record AS r ON r.id = fe.record_id"
				."\n    WHERE fe.field_id = ".$filter_field_id." {$where}
						AND fe.ref_id != 'index'"
				."\n  GROUP BY fe.value"
				."\n  ORDER by code,text";
				break;
				
			// Current category and subcategories
			case 3:	
				$ids = ResHelper::getCategoryChildrenIds($category);	
				$sql = "    SELECT fe.ref_id AS value,fe.value as text, COUNT( r.id ) as total , SUBSTRING_INDEX(fe.ref_id, '_', -1) as code"
	                           
				."\n      FROM #__js_res_field_extra   AS fe"
				."\n LEFT JOIN #__js_res_record          AS r  ON r.id = fe.record_id"
				."\n LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fe.record_id"
	            
				."\n     WHERE fe.field_id = ".$filter_field_id."
	                           AND rc.catid IN ({$ids}) {$where}
	                           AND fe.ref_id != 'index'"
				 
				."\n  GROUP BY fe.value"
				."\n  ORDER by code,text";
				break;
		}
		
		$db->setQuery( $sql );
		$exists_values = $db->loadAssocList();
		$result = array();
		$root = null;
		$parent = null;
		$temp_lenght = null;
		$index = 0;
		if(!empty($exists_values)){
			foreach ($exists_values as $value) {
				if( strlen($value['code']) == 2){
						if(!is_null($root))
							$result[] = $root;
							
						$root = $value;
						$parent = &$root;
						$temp_lenght = 2;
				}else{
					if( $temp_lenght < strlen($value['code'])){
						$temp_lenght = strlen($value['code']);
							
						if($temp_lenght < 17){
							$parent['children'][$index] = $value;
							$parent = &$parent['children'][$index++];
						}else{
							// add street
							$parent['children'][$index++] = $value;
						}
					}elseif($temp_lenght == strlen($value['code'])){
						// add more street and sort 
						$temp_lenght = strlen($value['code']);
						$parent['children'][$index++] = $value;
						if(count($parent['children']) > 1 ){
							uasort($parent['children'], array($this, 'streetSort'));
						}
					}else{
						$temp_lenght = strlen($value['code']);
						if($temp_lenght < 11)
							$parent = &$root;
						$parent['children'][$index] = $value;
						$parent = &$parent['children'][$index++];
					}
				}
					
			}	
		}
		if(!is_null($root))
			$result[] = $root;
		return $result;
	}
	
	function streetSort($a, $b){
		return strcmp( $a["text"], $b["text"]  );
	}

	function renderThemAll( $selected_values, $filter_id, $exists_values, $parent = null)
	{
		$result = "";

		$res = array();
		
		foreach( $exists_values as $cvalue => $obj ) {
			
			$sub_result = "";

			if( !empty($obj["children"]) ) {
				$sub_result = $this->renderThemAll( $selected_values, $filter_id, $obj["children"], $obj["code"] );
			}

			$div_sub_container_id = "jsfilter".$filter_id."_cdiv".$obj["code"];
			$imgspan_id           = "jsfilter".$filter_id."_cimgspan".$obj["code"];
			$checkbox_id          = "jsfilter".$filter_id."_ccheckbox".$obj["code"];

			$result .= "<span style='padding-right:5px;' id='".$imgspan_id."'>";

			if( isset($sub_result[1],$sub_result[0]) && $sub_result[0] ) {
				$event = "onclick='jsfilter".$filter_id."_collapse( \"jsfilter".$filter_id."_cdiv".$obj['code']."\", \"".$imgspan_id."\" )'";
				$img_src = "src='".JURI::root()."plugins/joomsuite_content/images/filter_kladr/expanded.png'";
			} else if ( !empty($obj["children"]) ) {
				$event = "onclick='jsfilter".$filter_id."_expand( \"jsfilter".$filter_id."_cdiv".$obj['code']."\", \"".$imgspan_id."\" )'";
				$img_src = "src='".JURI::root()."plugins/joomsuite_content/images/filter_kladr/collapsed.png'";
			} else {
				$event = "";
				$img_src = "src='".JURI::root()."plugins/joomsuite_content/images/filter_kladr/empty.png'";
			}

			$result .= "<img ".$img_src." ".$event." style='cursor: pointer;'>";
			$result .= "</span>";

			if( in_array( $obj["text"], $selected_values ) ) {
				$cheked = "checked='checked'";
				$res[0] = true;
			} else {
				$cheked = "";
			}
			if( isset($sub_result[0])){
				$res[0] = $sub_result[0];
			}

			$result .= "<input type='checkbox' ".$cheked." name='ext_filter".$filter_id."[]'; id='".$checkbox_id."' value='".htmlspecialchars( $obj['text'], ENT_QUOTES )."'>";


			$result .= $obj['text'].' ('.$obj['total'].')<br/>';
			 
			if( isset($sub_result[1]) ) {
				$result .= $sub_result[1];
			}
		}
		$div_container_id = "jsfilter".$filter_id."_cdiv".( $parent === null ? 'null' : $parent );
		$res[1] = "<div style='padding-left:25px;overflow:hidden;".(isset($res[0]) || $parent === null ? "" : "height:0px")."' id='".$div_container_id."'>".$result."</div>";
			
		return $res;
	}

}