<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_contentFilter_range extends JPlugin
{
	var $_error = true;
	
	function plgJoomsuite_contentFilter_range( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onFilterWhere(&$where, $filter, $prm, $category)
	{
		global $mainframe, $option;

		if($filter->type != 'range') return;

		if(!empty($filter->default[0]) && !empty($filter->default[1])) 
		{
			$fparams = $filter->exec_params;
			$fid = $fparams->get('ext_filter_field');
			
			settype($filter->default, 'array');
			
			JArrayHelper::toInteger($filter->default);
			$where[] = "r.id IN (SELECT record_id FROM #__js_res_record_values WHERE field_id = {$fid} AND field_value >= {$filter->default[0]} AND field_value <= {$filter->default[1]})";
		}

	}
	
	function onFilterLeftJoin(&$query, $filter, $params, $category)
	{}

	function onFilterWorn(&$out, $filter, $prm, $category)
	{
		if($filter->type != 'range') return;

		$str =  '%s %s %s - %s %s %s';
		$fparams = $filter->exec_params;
		$vals = $fparams->get('vals', 2);
		!isset($vals)? $vals = 0: null;
		$dec = $fparams->get('dec', '.');
		$dec == 'ws'? $dec = ' ': null;
		$thous = $fparams->get('thous', ',');
		$thous == 'ws'? $thous = ' ': null;
		$format = $fparams->get('format', 0);
		$default_0 = @$filter->default[0];
		$default_1 = @$filter->default[1];
		
		if ($format && is_numeric($default_0))
			$default_0 = number_format($default_0, $vals, $dec, $thous);
		if ($format && is_numeric($default_1))
			$default_1 = number_format($default_1, $vals, $dec, $thous);
		
		$fparams = $filter->exec_params;
		$str = sprintf($str,  $fparams->get('ext_filter_text_1'), $default_0, $fparams->get('ext_filter_text_2'),
		$fparams->get('ext_filter_text_3'), $default_1, $fparams->get('ext_filter_text_4'));

		$out = $str;
	}
	function onFilterRender(&$out, $filter, $category, $prm)
	{
		if($filter->type != 'range') return;
		$patern = '%s %s %s - %s %s %s';
		$fparams = $filter->exec_params;
		$fname_from = 'ext_filter'.$filter->id.'[]';
		$fname_to = 'ext_filter'.$filter->id.'[]';
		$vals = $fparams->get('vals', 2);
		!isset($vals)? $vals = 0: null;
		$dec = $fparams->get('dec', '.');
		$dec == 'ws'? $dec = ' ': null;
		$thous = $fparams->get('thous', ',');
		$thous == 'ws'? $thous = ' ': null;
		$format = $fparams->get('format', 0);

		switch($fparams->get('ext_filter_type'))
		{
			case 1:
				$from = sprintf('<input type="text" name="%s" value="%s" size="%d" />', $fname_from, @$filter->default[0], $fparams->get('ext_filter_size'));
				$to = sprintf('<input type="text" name="%s" value="%s" size="%d" />', $fname_to, @$filter->default[1], $fparams->get('ext_filter_size'));
				break;
			case 2:
				$db = JFactory::getDBO();
				$where = "AND r.published = 1
					#AND c.published = 1
					AND (r.extime = '0000-00-00 00:00:00' OR r.extime > NOW())
					AND r.ctime <= NOW()
					AND r.client = 'resource'";
				$show_num = $fparams->get('show_num', 0);
				switch ($prm->get('filters_mode', 1))
				{
					case 1:
						$sql = "SELECT fv.field_value AS value,";
						if ($show_num) $sql .= "CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text";
						else $sql .= "fv.field_value AS text";		
						$sql .= ", COUNT(r.id) as total
						FROM #__js_res_record_values as fv
						LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
						LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
						WHERE fv.field_id = ".$fparams->get('ext_filter_field')."
						AND rc.catid = {$category} {$where}
						GROUP BY fv.field_value";
						break;
					case 2:
						$sql = "SELECT fv.field_value AS value,";
						if ($show_num) $sql .= "CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text";
						else $sql .= "fv.field_value AS text";		
						$sql .= ", COUNT(r.id) as total
						FROM #__js_res_record_values as fv
						LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
						WHERE fv.field_id = ".$fparams->get('ext_filter_field')." {$where}
						GROUP BY fv.field_value";
						break;
					case 3:
						$ids = ResHelper::getCategoryChildrenIds($category);
						$sql = "SELECT fv.field_value AS value,";
						if ($show_num) $sql .= "CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text";
						else $sql .= "fv.field_value AS text";
						$sql .= ", COUNT(r.id) as total
						FROM #__js_res_record_values as fv
						LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
						LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
						WHERE fv.field_id = ".$fparams->get('ext_filter_field')."
						AND rc.catid IN ({$ids}) {$where}
						GROUP BY fv.field_value";
						break;
				}

				if($fparams->get('ext_filter_sort')) $sql .= ' ORDER BY ' . $fparams->get('ext_filter_sort');

				$db->setQuery($sql);
				$get = $db->loadObjectList();

				// check if data stored as serializes array
				if($get)
				{
					$array = array();
					foreach ($get AS $option)
					{
						if(!$option->value) continue;
						$add = @unserialize($option->value);
						if(is_array($add))
						{
							foreach($add AS $val)
							{
								$array[$val]->value = $val;
								if ($format && is_numeric($val)){
									$formated_val = number_format($val, $vals, $dec, $thous);
								}
								else{
									$formated_val = $val;
								}
								$array[$val]->text = $formated_val;
							}
						}
						else if (is_numeric($option->text) && $format){
							$formated_text = number_format($option->text, $vals, $dec, $thous);
							$option->text = $formated_text;
						}
					}
					if(count($array) > 0) $get = $array;
				}


				$option1[] = JHTML::_('select.option', '', $fparams->get('ext_filter_text_5'));
				if($get) $option1 = array_merge($option1, $get);
				//echo count($get);

				$option2[] = JHTML::_('select.option', '', $fparams->get('ext_filter_text_6'));
				if($get) $option2 = array_merge($option2, $get);

				//print_r($filter->defauilt); exit;

				$from 	= JHTML::_('select.genericlist', $option1, $fname_from, 'class="inputbox"', 'value', 'text', @$filter->default[0]);
				$to 	= JHTML::_('select.genericlist', $option2, $fname_to, 'class="inputbox"', 'value', 'text', @$filter->default[1]);
				break;
					
					case 3:

						$fromlist = explode("\n", $fparams->get('ext_filter_custom_1'));
						$tolist = explode("\n", $fparams->get('ext_filter_custom_2'));

						if(is_array($fromlist))
						{
							foreach ($fromlist AS $key => $option)
							{
								$from_list[$key]->value = $option;
								
								if ($format && is_numeric($option)){
									$formated_option = number_format($option, $vals, $dec, $thous);
								}
								else{
									$formated_option = $option;
								}
								$from_list[$key]->text = $formated_option;
							}
						}
						if(is_array($tolist))
						{
							foreach ($tolist AS $key => $option)
							{
								$to_list[$key]->value = $option;
								
								if ($format && is_numeric($option)){
									$formated_option = number_format($option, $vals, $dec, $thous);
								}
								else{
									$formated_option = $option;
								}
								$to_list[$key]->text = $formated_option;
							}
						}


						$option1[] = JHTML::_('select.option', '', $fparams->get('ext_filter_text_5'));
						if($from_list) $option1 = array_merge($option1, $from_list);
						//echo count($get);

						$option2[] = JHTML::_('select.option', '', $fparams->get('ext_filter_text_6'));
						if($to_list) $option2 = array_merge($option2, $to_list);

						//print_r($filter->defauilt); exit;

						$from 	= JHTML::_('select.genericlist', $option1, $fname_from, 'class="inputbox"', 'value', 'text', @$filter->default[0]);
						$to 	= JHTML::_('select.genericlist', $option2, $fname_to, 'class="inputbox"', 'value', 'text', @$filter->default[1]);
						break;
		}

		$out = sprintf($patern, $fparams->get('ext_filter_text_1'), $from, $fparams->get('ext_filter_text_2'),
		$fparams->get('ext_filter_text_3'), $to, $fparams->get('ext_filter_text_4'));
	}
}