<?php

defined ('_JEXEC') or die("Restricted Access");


class JS_Relate_Filter_Data_Source extends JObject
{
	
	var $parentData 	= null;
	
	var $childData 		= null;
	
	var $fieldParams 	= null;
	
	var $sectionParams 	= null;
	
	function __construct() {
		parent::__construct();
		
		require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php';
	}
	/**
	 * 
	 * @return JS_Relate_Filter_Data_Source
	 */
	function & getInstance() {
		static $instance = 0;
		if (empty($instance)) {
			$instance = new JS_Relate_Filter_Data_Source();	
		}
		
		return $instance;
	}
	
	
	function & getRelatedRecordsForParent($parentType, $sectionId, $order = '') {
		$parentType = (int)$parentType;
		$sectionId 	= (int)$sectionId;
		
		$sign = md5($parentType.$sectionId.$order);
		
		if (empty($this->parentData[ $sign ])) {
			$db = & JFactory::getDBO();
			
			$sectionParams 		= & $this->getSectionParams($sectionId);
			
			$showAllClients 	= $sectionParams->get('list_clients');
			$showFromCategories = $sectionParams->get('records_mode');
			
			if (!$showAllClients)
				$showAllClients = ' AND (r.client = "resource" OR r.client = "") ';
			else
				$showAllClients = '';

			// The parent section.
			$parentSection = ResHelper::getCategorySection($sectionId);
			
			// if we are in the section, and it is set to show records from all cats:
			if ($showFromCategories && $parentSection == $sectionId)
				$categoriesToLook = ResHelper::getCategoryChildrenIds($sectionId);
			else
				$categoriesToLook = $sectionId;
			
			$q = 'SELECT '.
				'r.id, r.title '.
				'FROM 				#__js_res_record AS r '.
				'INNER JOIN			#__js_res_field_extra AS	fe ON r.id = fe.field_value_id '.
				'INNER JOIN 		#__js_res_record_category AS rc ON rc.record_id = fe.record_id '.
				'WHERE fe.user_id = '.$parentType.' '.
				'AND rc.catid IN ('.$categoriesToLook.') '.
				$showAllClients.
				'GROUP BY r.id ';
			
			if (!empty($order))
				$q .= ' ORDER BY '.$order;
			
			$db->setQuery( $q );

			$this->parentData[ $sign ] = $db->loadObjectList();
		}
		
		return $this->parentData[ $sign ];
	}
	
	/**
	 * Fetches child record list.
	 * @param $parentType
	 * @param $childField
	 * @param $order
	 * @return unknown_type
	 */
	function & getRelatedRecordsForChild($parentType, $childField, $sectionId, $order = '') {
		$parentType = (int)$parentType;
		$childField = (int)$childField;
		$sectionId 	= (int)$sectionId;
		
		$sign = md5($parentType.$childField.$order);
		
		if (empty($this->childData[ $sign ])) {
			$db = & JFactory::getDBO();
			
			$sectionParams 		= & $this->getSectionParams($sectionId);
			
			$showAllClients 	= $sectionParams->get('list_clients');
			$showFromCategories = $sectionParams->get('records_mode');
			
			if (!$showAllClients)
				$showAllClients = ' AND (r.client = "resource" OR r.client = "") ';
			else
				$showAllClients = '';

			// The parent section.
			$parentSection = ResHelper::getCategorySection($sectionId);
			
			// if we are in the section, and it is set to show records from all cats:
			if ($showFromCategories && $parentSection == $sectionId)
				$categoriesToLook = ResHelper::getCategoryChildrenIds($sectionId);
			else
				$categoriesToLook = $sectionId;

			$q = 'SELECT '.
				'r.id, r.title '.
				'FROM 				#__js_res_record AS r '.
				'LEFT OUTER JOIN	#__js_res_field_extra AS fe ON r.id = fe.record_id '.
				'LEFT JOIN 			#__js_res_record_category AS rc ON rc.record_id = fe.field_value_id '.
				'WHERE '.
					'fe.user_id = '.(int)$parentType.' AND fe.field_id = '.(int)$childField.' '.
					$showAllClients.
					' AND rc.catid IN ('.$categoriesToLook.') '.
				'GROUP BY r.id ';
			
			if (!empty($order))
				$q .= ' ORDER BY '.$order;
			
			$db->setQuery( $q );
			
			$this->childData[ $sign ] = $db->loadObjectList();
		}
		
		return $this->childData[ $sign ];
	}
	
	/**
	 * Returns field parameters.
	 * @param $fieldId int field id.
	 * @return JParameter
	 */
	function &getFieldParams($fieldId) {
		if (!empty($this->fieldParams[$fieldId]))
			return $this->fieldParams[$fieldId];
		
		$db = & JFactory::getDBO();
		
		$q = 'SELECT id, params FROM #__js_res_fields WHERE id = '.(int)$fieldId;
		$db->setQuery( $q );
		
		$result = $db->loadObject();
		if (!$result)
			return $result;
		
		$this->fieldParams[$fieldId] = new JParameter($result->params);
		
		return $this->fieldParams[$fieldId];
	}
	
	function & getSectionParams( $catid ) {
		$sectionId = ResHelper::getCategorySection($catid);
		
		if (empty($this->sectionParams[ $sectionId ])) {
			$this->sectionParams[ $sectionId ] = ResHelper::getSectionParams($sectionId);
		}
		return $this->sectionParams[ $sectionId ];
	}
}