<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_contentFilter_Relate_Parent extends JPlugin
{
	var $_error = true;
	var $_sectionParams = null;
	
	function plgJoomsuite_contentFilter_Relate_Parent(&$subject, $params)
	{
		parent::__construct( $subject, $params );
	}

	function onFilterWhere(&$where, $filter, $prm, $category)
	{
		global $mainframe, $option;
		if($filter->type != 'relate_parent') 
			return;

		$fparams = $filter->exec_params;

		if (!empty($filter->default) && is_array($filter->default))
		{
			JArrayHelper::toInteger($filter->default);
			$filter->default = array_unique($filter->default);
			$ext_type = (int)$fparams->get('ext_filter_parent_type');
			$ids = implode(',',$filter->default);
			$where[] = "r.id IN (SELECT record_id FROM #__js_res_field_extra WHERE user_id = {$ext_type} AND field_value_id IN({$ids}))";
		}
	}
	
	function onFilterLeftJoin(&$query, $filter, $params, $category)
	{
		/*if ($filter->type != 'relate_parent') 
			return;

		if (!empty($filter->default) && is_array($filter->default))
		{
			$filter->default = array_unique($filter->default);
			$c = 0;
			foreach ($filter->default as $v) {
				$query[] = ' LEFT JOIN #__js_res_field_extra AS ffe'.$c.' ON ffe'.$c.'.record_id = v.record_id AND ffe'.$c.'.user_id = r.type_id ';
				$c++;
			}
		}*/
	}

	function onFilterWorn(&$out, $filter, $prm, $category)
	{
		if ($filter->type != 'relate_parent') 
			return;

		$params = $filter->exec_params;
		$out = '';
		
		require_once JPATH_ROOT.DS.'plugins'.DS.'joomsuite_content'.DS.'filter_relate'.DS.'data_source.php';
		$dataSource 	= & JS_Relate_Filter_Data_Source::getInstance();
		
		$sectionId 		= JRequest::getInt('section_id', JRequest::getInt('category_id'));
		$relatedRecords = & $dataSource->getRelatedRecordsForParent($params->get('ext_filter_parent_type'), $sectionId, $params->get('ext_filter_suggestions_sort'));
		
		if (!empty($filter->default) && is_array($filter->default))
		{
			$filter->default = array_unique($filter->default);
			
			$filterRecords = array();
			
			foreach ($filter->default as $recordId) {
				foreach ($relatedRecords as $rec) {
					if ($rec->id == $recordId) {
						$filterRecords [] = $rec->title;
						break;						
					}
				}
			}
			
			$out .= implode(', ', $filterRecords);
		}		
	}
	
	function onFilterRender(&$out, $filter, $category, $prm)
	{
		if($filter->type != 'relate_parent') 
			return;
			
		require_once JPATH_ROOT.DS.'plugins'.DS.'joomsuite_content'.DS.'filter_relate'.DS.'data_source.php';
	
		$params 	= & $filter->exec_params;
		$filterName = 'ext_filter'.$filter->id.'[]';
		
		if ($params->get('ext_filter_type', 'autocomplete') == 'autocomplete')
			$out = $this->_renderAutocomplete($filter, $params);
		else
			$out = $this->_renderSelectList($filter, $params);
	}
	
	function _renderSelectList(&$filter, $params) {
		$dataSource = & JS_Relate_Filter_Data_Source::getInstance();
		
		$filterName 	= 'ext_filter'.$filter->id.'[]';
		
		$sectionId 		= JRequest::getInt('section_id', JRequest::getInt('category_id'));
		$relatedRecords = & $dataSource->getRelatedRecordsForParent($params->get('ext_filter_parent_type'), $sectionId, $params->get('ext_filter_suggestions_sort'));
		
		$options = array();
		$selected = null;
		$options [] = JHTML::_('select.option', '', JText::_($params->get('ext_filter_select_dummy', '')));
		foreach ($relatedRecords as $record) {
			$options [] = JHTML::_('select.option', $record->id, $record->title);
			
			if (!empty($filter->default[0]) && $filter->default[0] == $record->id) {
				$selected = $record->id;
			}
		}
		
		return JHTML::_('select.genericlist', $options, $filterName, 'class="inputbox"', 'value', 'text', $selected);
	}
	
	function _renderAutocomplete(&$filter, $params) {
		JHTML::_('behavior.mootools');
		
		$document = & JFactory::getDocument();
		$document->addScript(JURI::root().'plugins/joomsuite_content/filter_relate/autocomplete.js');
		$document->addStyleSheet(JURI::root().'plugins/joomsuite_content/filter_relate/AutoComplete.css');
		
		$filterName = 'ext_filter'.$filter->id.'[]';
		
		$dataSource = & JS_Relate_Filter_Data_Source::getInstance();
		
		$recordsJS 		= array();
		$selected 		= new stdClass;
		$selected->id 	= null;
		$selected->text = null;
		
		$sectionId 		= JRequest::getInt('section_id', JRequest::getInt('category_id'));
		$relatedRecords = & $dataSource->getRelatedRecordsForParent($params->get('ext_filter_parent_type'), $sectionId, $params->get('ext_filter_suggestions_sort'));
		
		foreach ($relatedRecords as $record) { 
			$recordsJS [] = '{id: '. $record->id. ', text: \''. addslashes($record->title). '\'}';
			if (!empty($filter->default[0])) {
				if ($record->id == $filter->default[0]) {
					$selected->id 	= $record->id;
					$selected->text = $record->title;
				} 
			}
		}
		
		$uid = uniqid('a');
		ob_start();
		
?>
window.addEvent('domready', function () {
	AutoComplete_Create('autocompleteArea<?php echo $uid; ?>', [<?php echo implode(', ', $recordsJS); ?>], '<?php echo $filterName; ?>', 6);
	<?php if ($selected->id) : ?>
	var input = document.createElement('INPUT');
	input.type = 'hidden';
	input.value = <?php echo $selected->id; ?>;
	input.name = '<?php echo addslashes($filterName); ?>';
	
	// Add the input
	$('autocompleteArea<?php echo $uid; ?>').parentNode.insertBefore(input, $('autocompleteArea<?php echo $uid; ?>'));
	$('autocompleteArea<?php echo $uid; ?>').value = '<?php echo @addslashes(@$selected->text); ?>';
	<?php endif; ?>
});
<?php
		// Inlude the javascript
		$js = ob_get_clean();
		$document->addScriptDeclaration($js);
		ob_start();
?>	
<input type="text" id="autocompleteArea<?php echo $uid; ?>" />
<?php	
		return ob_get_clean();
	}
		
	function _initParams() {
		if (empty($this->_sectionParams)) {
			require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php';
			
			$this->_sectionParams = ResHelper::initListParams(JRequest::getInt('category_id'));
		}
	}
}