<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_contentFilter_Rent extends JPlugin
{

	function plgJoomsuite_contentFilter_Rent(&$subject, $params)
	{
		parent::__construct( $subject, $params );
	}

	function onFilterWhere(&$where, $filter, $prm, $category)
	{
		global $mainframe, $option;
		if($filter->type != 'rent') return;

		$fparams = $filter->exec_params;
		$default = $filter->default;
		if(count($default))
		{
			$db = &JFactory::getDBO();
			ksort($default);
			$fwhere = array();

			$sql = "SELECT id FROM #__js_res_fields WHERE type='product_property_rent' AND published = '1'";
			$db->setQuery($sql);
			if($rent_id = $db->loadResultArray())
			{
				$fwhere[] = "res_rv.field_id IN (".implode(', ', $rent_id).")";
			}
			if($fparams->get('ext_filter_type', 'strict') == 'range')
			{
				$range = array();
				switch($fparams->get('ext_filter_by', 'day'))
				{
					case 'hour':
						if( strtotime($default[0]) > strtotime($default[2]))
						{
							JError::raiseWarning(100, $filter->title.': '.JText::_('Date From could not be later than date To'));
							return;
						}
						if( strtotime($default[0]) == strtotime($default[2]))
						{
							if( $default[1] > $default[3])
							{
								JError::raiseWarning(100, $filter->title.': '.JText::_('Time From could not be later than time To'));
								return;
							}
						}
						$range[0] = $default[0].'-'.$default[1];
						$range[1] = $default[2].'-'.$default[3];
						
						$days_between = ( strtotime($default[2]) - strtotime($default[0]) ) / 86400;
						$hours_between = $default[3] - $default[1];
						$btw = array();
						$btw[] = "'".$range[0]."'";

						$val = explode('-', $range[0]);
						$month1 = $val[0].'-'.$val[1];
						$val = explode('-', $range[1]);
						$month2 = $val[0].'-'.$val[1];

						$sql = "SELECT PERIOD_DIFF(".str_replace('-', '', $month2).", ".str_replace('-', '', $month1).")";
						$db->setQuery($sql);
						$months_between = $db->loadResult();

						$btwl = array();
						if(!$days_between )
						{
							for($i = 1; $i <= $hours_between; $i++)
							{
								$btw[] = "'".$default[0].'-'.($default[1] + $i)."'";
							}
						}
						else
						{
							for($i = ($default[1] + 1); $i <= 23; $i++)
							{
								$btw[] = "'".$default[0].'-'.$i."'";
							}
							if($days_between > 1)
							{
								if($months_between > 1)
								{
									$to = date("t", strtotime($default[0])) - date("j", strtotime($default[0]));
									$from = date("j", strtotime($default[2]));
									for($i = 0; $i <= $to; $i++)
									{
										$like = date("Y-m-j", strtotime("+$i days", strtotime($default[0])));
										$btwl[] = " opp.property LIKE '$like%'";
									}
									for($i = 1; $i < $months_between; $i++)
									{
										$like = date("Y-m", strtotime("+$i months", strtotime($default[0])));
										$btwl[] = " opp.property LIKE '$like%'";
									}
									for($i = ($from - 1); $i >= 0; $i--)
									{
										$like = date("Y-m-j", strtotime("-$i days", strtotime($default[2])));
										$btwl[] = " opp.property LIKE '$like%'";
									}
								}
								else
								{
									for($i = 1; $i <= $days_between; $i++)
									{
										$like = date("Y-m-j", strtotime("+$i days", strtotime($default[0])));
										$btwl[] = " opp.property LIKE '$like%'";
									}
								}
							}
							for($i = 0; $i <= $default[3]; $i++)
							{
								$btw[] = "'".$default[2].'-'.$i."'";
							}
						}
						$btw[] = "'".$month1."'";
						if($months_between)
						{
							for ($i = 1; $i <= $months_between; $i ++ )
							{
								$sql = "SELECT DATE_FORMAT('".$month1."-01' + INTERVAL $i MONTH, '%Y-%m')";
								$db->setQuery($sql);
								if($like = $db->loadResult())
								$btw[] = "'".$like."'";
							}
						}

						$sql = "SELECT DISTINCT(product_id)
						FROM #__jc_orders_products AS op
						LEFT JOIN #__jc_orders_products_property AS opp ON opp.order_product_id = op.id
						WHERE op.status_id IN (2, 5) AND ( opp.property IN ( ".implode(', ', $btw)." )
						".( count($btwl) > 0 ? " OR ".implode(' OR ', $btwl) : '' )."  )";

						$db->setQuery($sql);
						if($rec_id = $db->loadResultArray())
						{
							$fwhere[] = " r.id NOT IN  (".implode(', ', $rec_id).")";
						}
						break;

					case 'day':
						if( strtotime($default[0]) > strtotime($default[1]))
						{
							JError::raiseWarning(100, $filter->title.': '.JText::_('Date From could not be later than date To'));
							return;
						}
						$range[0] = $default[0];
						$val = explode('-', $range[0]);
						$month1 = $val[0].'-'.$val[1];
						
						$range[1] = $default[1];
						$val = explode('-', $range[1]);
						$month2 = $val[0].'-'.$val[1];
						
						$days_between = ( strtotime($range[1]) - strtotime($range[0]) ) / 86400;
						$btw = array();
						$btw[] = " opp.property LIKE '".$range[0]."%'";
						if($days_between)
						{
							for ($i = 1; $i <= $days_between; $i ++ )
							{
								$like = date("Y-m-j", strtotime("+$i ". ($i == 1 ? "day" : 'days'), strtotime($range[0])));
								$btw[] = " opp.property LIKE '$like%'";
							}
						}
						$sql = "SELECT PERIOD_DIFF(".str_replace('-', '', $month2).", ".str_replace('-', '', $month1).")";
						$db->setQuery($sql);
						$months_between = $db->loadResult();
						$btwm = array();
						$btwm[] = "'".$month1."'";
						if($months_between)
						{
							for ($i = 1; $i <= $months_between; $i ++ )
							{
								$sql = "SELECT DATE_FORMAT('".$month1."-01' + INTERVAL $i MONTH, '%Y-%m')";
								$db->setQuery($sql);
								if($like = $db->loadResult())
								$btwm[] = "'".$like."'";
							}
						}

						$sql = "SELECT DISTINCT(product_id)
						FROM #__jc_orders_products AS op
						LEFT JOIN #__jc_orders_products_property AS opp ON opp.order_product_id = op.id
						WHERE op.status_id IN (2, 5) AND ( ".implode(' OR ', $btw)."
						".( count($btwm) > 0 ? " OR opp.property IN ( ".implode(', ', $btwm).') ' : '').")";
						$db->setQuery($sql);
						if($rec_id = $db->loadResultArray())
						{
							$fwhere[] = " r.id NOT IN  (".implode(', ', $rec_id).")";
						}
						break;
					case 'month':
						if( strtotime($default[0]) > strtotime($default[1]))
						{
							JError::raiseWarning(100, $filter->title.': '.JText::_('Date From could not be later than date To'));
							return;
						}
						$range[0] = $default[0];
						$range[1] = $default[1];
						$sql = "SELECT PERIOD_DIFF(".str_replace('-', '', $range[1]).", ".str_replace('-', '', $range[0]).")";
						$db->setQuery($sql);
						$months_between = $db->loadResult();
						if($months_between)
						{
							$btw = array();
							$btw[] = " opp.property LIKE '".$range[0]."%'";
							for ($i = 1; $i <= $months_between; $i ++ )
							{
								$sql = "SELECT DATE_FORMAT('".$range[0]."-01' + INTERVAL $i MONTH, '%Y-%m')";
								$db->setQuery($sql);
								$like = $db->loadResult();
								$btw[] = " opp.property LIKE '$like%'";
							}
						}
						$sql = "SELECT DISTINCT(product_id)
						FROM #__jc_orders_products AS op
						LEFT JOIN #__jc_orders_products_property AS opp ON opp.order_product_id = op.id
						WHERE op.status_id IN (2, 5) AND ( ".implode(' OR ', $btw)." )";
						$db->setQuery($sql);
						if($rec_id = $db->loadResultArray())
						{
							$fwhere[] = " r.id NOT IN  (".implode(', ', $rec_id).")";
						}
						break;
				}
			}
			else
			{
				$default = implode('-', $default);
				if ($default != '')
				{
					$val = explode('-', $default);
					$month = $val[0].'-'.$val[1];
					if($fparams->get('ext_filter_by', 'day') == 'hour')
					$day = $val[0].'-'.$val[1].'-'.intval($val[2]);

					$sql = "SELECT DISTINCT(product_id)
					FROM #__jc_orders_products AS op
					LEFT JOIN #__jc_orders_products_property AS opp ON opp.order_product_id = op.id
					WHERE op.status_id IN (2, 5) AND (opp.property = '$default' OR opp.property = '$month'
					".( ($fparams->get('ext_filter_by', 'day') == 'hour') ? " OR opp.property = '$day' " : '' ) ." )";
					$db->setQuery($sql);
					if($rec_id = $db->loadResultArray())
					{
						$fwhere[] = " r.id NOT IN  (".implode(', ', $rec_id).")";
					}
				}
			}
			if(count($fwhere))
			$where[] = '('.implode(' AND ', $fwhere).")";
		}
	}

	function onFilterLeftJoin(&$query, $filter, $params, $category)
	{
		/*if ($filter->type != 'rent') return;

		$default = $filter->default;
		if(count($default))
		{
			ksort($default);
			$default = implode('-', $default);
			if ($default != '')
			{
				$query[] = 'LEFT JOIN #__jc_orders_products AS op ON op.product_id = v.record_id';
				$query[] = 'LEFT JOIN #__jc_orders_products_property AS opp ON opp.order_product_id = op.id ';
			}
		}*/
	}

	function onFilterWorn(&$out, $filter, $prm, $category)
	{
		if ($filter->type != 'rent') return;

		$default = $filter->default;
		$print = array();
		if(count($default))
		{
			jimport('joomla.utilities.date');
			$params = $filter->exec_params;
			switch($params->get('ext_filter_by', 'day'))
			{
				case 'hour':
					$hours = array();
					for($i = 0; $i < 24; $i++ )
					{
						$hours[] = $i < 10 ? '0'.$i : $i;
						$hours_to[] = ($i+1 < 10) ? '0'.($i+1) : $i+1;
					}
					$time = new JDate($default[0]);

					if($params->get('ext_filter_type', 'strict') == 'range')
					{
						$print[] = $hours[$default[1]].':00, ';
						$print[] = $time->toFormat('%d %b %Y');
						$print[] = '-';
						$time = new JDate($default[2]);
						$print[] = $hours_to[$default[3]].':00, ';
						$print[] = $time->toFormat('%d %b %Y');
					}
					else
					{
						$print[] = $hours[$default[1]].':00 - '.$hours_to[$default[1]].':00, ';
						$print[] = $time->toFormat('%d %b %Y');
					}
					break;
				case 'day':
					$time = new JDate($default[0]);

					$print[] = $time->toFormat('%d %b %Y');
					if($params->get('ext_filter_type', 'strict') == 'range')
					{
						$print[] = '-';
						$time = new JDate($default[1]);
						$print[] = $time->toFormat('%d %b %Y');
					}
					break;
				case 'month':
					$time = new JDate($default[0].'-01');
					$print[] = $time->toFormat('%b %Y');
					if($params->get('ext_filter_type', 'strict') == 'range')
					{
						$print[] = '-';
						$time = new JDate($default[1].'-01');
						$print[] = $time->toFormat('%b %Y');
					}
					break;
			}
			$out .= implode(' ', $print);
		}

	}

	function onFilterRender(&$out, $filter, $category, $prm)
	{
		if($filter->type != 'rent') return;

		$params = $filter->exec_params;
		JHTML::_('behavior.calendar');
		$default = $filter->default;
		$out = '';
		if($params->get('ext_filter_text') != '')
		$out .= JText::_($params->get('ext_filter_text')).'<br>';
		$print = array();
		switch($params->get('ext_filter_by', 'day'))
		{
			case 'hour':
				$hours = array();
				for($i = 0; $i < 24; $i++ )
				{
					$hours[] = $i < 10 ? '0'.$i : $i;
					$hours_to[] = ($i+1 < 10) ? '0'.($i+1) : $i+1;
				}
				$opt = array();
				$opt[] = JHTML::_('select.option', '', '- '.JText::_('Select time period').' -');
				foreach ($hours as $k => $hour)
				{
					$opt[] = JHTML::_('select.option', $k, $hour.':00 - '.$hours_to[$k].':00');
				}
				if($params->get('ext_filter_type', 'strict') == 'range')
				{
					$print[] = JText::_('From');
					$opt = array();
					$opt[] = JHTML::_('select.option', '', '- '.JText::_('Time').' -');
					foreach ($hours as $k => $hour)
					{
						$opt[] = JHTML::_('select.option', $k, $hour.':00');
					}
					$print[] = JHTML::_('select.genericlist', $opt, 'ext_filter'.$filter->id.'[1]', 'class="inputbox"', 'value', 'text', $default[1]);
					$print[] = JHTML::_('calendar', ( (count($default) && $default[0] != '') ? $default[0] : '') , 'ext_filter'.$filter->id.'[0]', 'ctime', '%Y-%m-%d', array('class' => 'inputbox', 'maxlength' => 10, 'size' => 10));

					$print[] = JText::_('To');
					$opt = array();
					$opt[] = JHTML::_('select.option', '', '- '.JText::_('Time').' -');
					foreach ($hours_to as $k => $hour)
					{
						$opt[] = JHTML::_('select.option', $k, $hour.':00');
					}
					$print[] = JHTML::_('select.genericlist', $opt, 'ext_filter'.$filter->id.'[3]', 'class="inputbox"', 'value', 'text', $default[3]);
					$print[] = JHTML::_('calendar', ( (count($default) && $default[2] != '') ? $default[2] : '') , 'ext_filter'.$filter->id.'[2]', 'extime', '%Y-%m-%d', array('class' => 'inputbox', 'maxlength' => 10, 'size' => 10));

				}
				else
				{
					$print[] = JHTML::_('select.genericlist', $opt, 'ext_filter'.$filter->id.'[1]', 'class="inputbox"', 'value', 'text', $default[1]);
					$print[] = JHTML::_('calendar', ( (count($default) && $default[0] != '') ? $default[0] : '') , 'ext_filter'.$filter->id.'[0]', 'ctime', '%Y-%m-%d', array('class' => 'inputbox', 'maxlength' => 10, 'size' => 10));
				}
				break;
			case 'day':
				if($params->get('ext_filter_type', 'strict') == 'range')
				{
					$print[] = JText::_('From');
				}
				$print[] = JHTML::_('calendar', ((count($default) && $default[0] != '') ? $default[0] : '') ,  'ext_filter'.$filter->id.'[]', 'ctime', '%Y-%m-%d', array('class' => 'inputbox', 'maxlength' => 10, 'size' => 10));
				if($params->get('ext_filter_type', 'strict') == 'range')
				{
					$print[] = JText::_('To');
					$print[] = JHTML::_('calendar', ((count($default) && $default[1] != '') ? $default[1] : '') ,  'ext_filter'.$filter->id.'[]', 'extime', '%Y-%m-%d', array('class' => 'inputbox', 'maxlength' => 10, 'size' => 10));
				}
				break;
			case 'month':
				if($params->get('ext_filter_type', 'strict') == 'range')
				{
					$print[] = JText::_('From');
				}
				$print[] = JHTML::_('calendar', ((count($default) && $default[0] != '') ? $default[0] : '') , 'ext_filter'.$filter->id.'[]', 'ctime', '%Y-%m', array('class' => 'inputbox', 'maxlength' => 7, 'size' => 10));
				if($params->get('ext_filter_type', 'strict') == 'range')
				{
					$print[] = JText::_('To');
					$print[] = JHTML::_('calendar', ((count($default) && $default[1] != '') ? $default[1] : '') , 'ext_filter'.$filter->id.'[]', 'extime', '%Y-%m', array('class' => 'inputbox', 'maxlength' => 7, 'size' => 10));
				}
				break;
		}
		$out .= implode(' ', $print);
	}
}