<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_contentFilter_zip_distance extends JPlugin
{
	var $_error = null;
	var $table = '#__zip_code_us';
	var $legacy = false;
	
	function plgJoomsuite_contentFilter_zip_distance( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onFilterWhere(&$where, $filter, $prm, $category)
	{
		global $mainframe, $option;

		if($filter->type != 'zip_distance') return;
		if(!$filter->default[0] || !$filter->default[1] || $this->_error)
		{	
			$filter->default[0] = null;
			$filter->default[1] = null;
			return;
		}
		
		//$itemid = JRequest::getInt('Itemid');
		$cord_range = $this->get_zip_range($filter);
		
		if($this->_error)
		{	
			$filter->default[0] = null;
			$filter->default[1] = null;
			return;
		}
		$field_type = $prm->get('field_type', 'text');
		$zip_field = $prm->get('zip_field');
		
		switch ($field_type){
			case 'text':
				$value = "IN (SELECT zip_code FROM {$this->table} WHERE (lat BETWEEN {$cord_range['lat1']} AND {$cord_range['lat2']}) AND (lon BETWEEN {$cord_range['lon1']} AND {$cord_range['lon2']}))";
				//$query[] = " LEFT JOIN {$this->table} AS zip ON zip.zip_code LIKE CONCAT(v.field_value, '%') ";
			break;
			case 'address':
				$value = "IN (SELECT zip_code FROM {$this->table} WHERE (lat BETWEEN {$cord_range['lat1']} AND {$cord_range['lat2']}) AND (lon BETWEEN {$cord_range['lon1']} AND {$cord_range['lon2']}))";
				//$query[] = " LEFT JOIN {$this->table} AS zip ON v.field_value REGEXP CONCAT('\".*', zip.zip_code, '.*\"') ";
			break;
		}
		$where[] = "r.id IN (SELECT record_id FROM #__js_res_record_values WHERE field_id = {$zip_field} field_value {$value})";
		//zip.lat BETWEEN '.$cord_range['lat1'].' AND '.$cord_range['lat2'].') AND (zip.lon BETWEEN '.$cord_range['lon1'].' AND '.$cord_range['lon2'].' )';
			
//
//			foreach ($zip_range as $key=>$zip){
//			$where .="(ev".$zip_field.".field_value LIKE '%".$zip."%')";
//			if ($key != (count($zip_range) - 1)) $where .= " OR ";
//		}
//		echo $where; exit;
//		$where = array($where);
		
	}
	
	function onFilterLeftJoin(&$query, $filter, $params, $category)
	{
		if($filter->type != 'zip_distance') return;
		$cord_range = $this->get_zip_range($filter);
		if(!$filter->default[0] || !$filter->default[1] || $this->_error)
		{	
			static $say_one = false;
			$filter->default[0] = null;
			$filter->default[1] = null;
			if ($this->_error && !$say_one){
			JError::raiseNotice(100, $filter->title.': '.$this->_error.'<img hspace="0" onclick="document.adminForm.ext_filter_'.$filter->id.'.value=1; document.adminForm.submit();" style="cursor:pointer; float: right;" src="'.JURI::root().'components/com_resource/images/icons/cancel.png" title="Clear filter"/>');
			$say_one = true;
			}
			return;
		}
		$fparams = $filter->exec_params;
		$zip_field = $fparams->get('zip_field');
		
		if($filter->default)
		{
			//$query[] = " LEFT JOIN #__js_res_record_values AS ev$zip_field ON ev$zip_field.record_id = r.id AND ev$zip_field.field_id = ".$fparams->get('zip_field');
			$field_type = $fparams->get('field_type', 'text');
			switch ($field_type){
				case 'text':
				$query[] = " LEFT JOIN {$this->table} AS zip ON zip.zip_code LIKE CONCAT(v.field_value, '%') ";
				break;
				case 'address':
				$query[] = " LEFT JOIN {$this->table} AS zip ON v.field_value REGEXP CONCAT('\".*', zip.zip_code, '.*\"') ";
				break;
			}
			//print_r($query); exit;
			//$query .= " LEFT JOIN #__js_res_fields AS ef".$zip_field." ON ef".$zip_field.".id = ev".$zip_field.".field_id ";
		}
	}

	function onFilterWorn(&$out, $filter, $prm, $category)
	{
		if($filter->type != 'zip_distance') return;
		$fparams = $filter->exec_params;
		$measure = $fparams->get('measure', 'm');
		if ($measure == 'm') {
			$measure_full = JText::_('mile(s)');
			}
		else if ($measure == 'km') {
			$measure_full = JText::_('kilometer(s)');
		}
		$zip = @$filter->default[0];
		$distance = @$filter->default[1];
		$country = strtoupper(@$filter->default[2]);
		
		$str =  JText::_('From ZIP:')."($country) %s ".JText::_('Within distance:')." %s $measure_full";
		$str = sprintf($str,  $zip, $distance);
		$out = $str;
	}
	
	function onFilterRender(&$out, $filter, $category, $prm)
	{
		if($filter->type != 'zip_distance') return;
		
		$fparams = @$filter->exec_params;
		$measure = @$fparams->get('measure', 'm');
		if ($measure == 'm') {
			$measure_full = JText::_('mile(s)');
			}
		else if ($measure == 'km') {
			$measure_full = JText::_('kilometer(s)');
		}

		$zip = @$filter->default[0];
		$distance = @$filter->default[1];
		$country = @$filter->default[2];
		$fid = 'ext_filter'.$filter->id;
		$fname = $fid.'[]';
		$patern = JText::_('From ZIP:')." %s ".JText::_('Within distance:')." %s $measure_full";
		
		$zip_input = "<input type='text' name='$fname' value='$zip' id='{$fid}_zip' size='5'>";
		
		$input = $fparams->get('input_type', 'select');
		if ($input == 'input'){
		$distance_input = "<input type='text' name='$fname' value='$distance' id='{$fid}_distance' size='4'>";
		}
		else if ($input = 'select'){
		if ($fparams->get('custom_select'))
		$default = $fparams->get('custom_select');
		else
		$default = "2\n5\n10\n15\n25\n35\n50\n70\n100\n150\n200";
		
		$custom_select_list = explode("\n", $default);
		if(count($custom_select_list)>1)
			{
				foreach ($custom_select_list AS $key => $custom_select_item)
				{
					$custom_select[$key]->value = $custom_select_item;
					$custom_select[$key]->text = $custom_select_item;
				}
			$distance_input	= JHTML::_('select.genericlist', $custom_select, $fname, 'class="inputbox"', 'value', 'text', $distance);			
			}
		else
			$distance_input = "<input type='text' name='$fname' value='{$custom_select_list[0]}' id='{$fid}_distance' size='4' disabled='disabled'>";
		}
		$str = sprintf($patern, $zip_input, $distance_input);
		///check for countries
		$countries = $fparams->get('countries');
		if ($countries){
			if (is_array($countries)){
				foreach ($countries as $country_){
					$select[] = JHTML::_('select.option', $country_, strtoupper($country_));
				}
				$out = $str.' '.JText::_('Country:').JHTML::_('select.genericlist', $select, $fname, 'class="inputbox"', 'value', 'text', $country);
			}
			else {
				if (!$country) $country = $countries;
				$out = $str."<input type='hidden' name='$fname' value='$country' id='{$fid}_country' size='4'>";				
			}			
		}
		else {
			$out = $str."<input type='hidden' name='$fname' value='us' id='{$fid}_country' size='4'>";
		}
			
	}
	
	
		//Part of this function is taken from http://www.102degrees.com/blog/2009/05/27/using-php-to-find-distance-between-zip-codes/ Thank you Aaron!//
	   ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function get_zip_range($filter)
	{
		//Just check for any case//
	   ///////////////////////////			
		if (!$filter->default[0] || !$filter->default[1] || $this->_error){
			return;
		}
		$fparams = $filter->exec_params;
		$measure = $fparams->get('measure', 'm');
		$zip = @$filter->default[0];
		$distance = @$filter->default[1];
		$country = @$filter->default[2];
		$this->table_select($country);
		$zip_field = $fparams->get('zip_field');
		//Check if zip codes table exist//
	   //////////////////////////////////
		$db = & Jfactory::getDBO();
		$config =& JFactory::getConfig();
		$pref = $config->getValue( 'config.dbprefix' );
		$table = str_replace('#__', $pref, $this->table);
		$sql = "SHOW TABLES LIKE '$table'";
		$db->setQuery($sql);
		$check = $db->loadResult();
		//Check if zip codes table exist from JUser, for legacy compatibility//
		$sql = "SHOW TABLES LIKE '{$pref}juser_zip_code'";
		$db->setQuery($sql);
		$check_leg = $db->loadResult();
		
		if (!$check && !$check_leg){
			$filter->default[0] = null;
			$filter->default[1] = null;
			$this->_error = Jtext::_('The ZIP codes table is not found!');
			return $filter;
		}
		else if (!$check && $check_leg){
			$this->legacy = true;
			$this->table = "#__juser_zip_code";
		}
		//Check if zip code formated//
	   /////////////////////////////////////
	   	$sql = "SELECT MAX(CHAR_LENGTH(zip_code)) FROM {$this->table} WHERE 1;";
	   	$db->setQuery($sql);
		$max = $db->loadResult();
	   	$sql = "SELECT MIN(CHAR_LENGTH(zip_code)) FROM {$this->table} WHERE 1;";
	   	$db->setQuery($sql);
		$min = $db->loadResult();
		if ((strlen($zip) > $max || strlen($zip)< $min) && isset($zip)){
			if ($max == $min) 
			$length = $max;
			else
			$length = $min.'-'.$max;
			$filter->default[0] = null;
			$filter->default[1] = null;
			$this->_error = Jtext::_("ZIP has not proper length!").'('.$length.')';
			return $filter;
		}	
		
		//Continue if OK//
		/////////////////
		if ($measure == 'm') {
			$miles = $distance;
			}
		else if ($measure == 'km') {
			$miles = $distance * 0.621371192;
		}

		$sql = "SELECT `lat`, `lon` FROM {$this->table} WHERE zip_code LIKE '$zip' OR zip_code LIKE UPPER('$zip')";
		$db->setQuery($sql);
		$latlong = $db->loadRow();

		// Check if taken lantitude and longtitude are valid //
	   ///////////////////////////////////////////////////////
		if (!$latlong){
			$filter->default[0] = null;
			$filter->default[1] = null;
			$this->_error = Jtext::_('ZIP code is not found');
			
			return $filter;			
		}
		else if ($latlong[0] == 0 && $latlong[1] == 0) {
			$filter->default[0] = null;
			$filter->default[1] = null;
			$this->_error = Jtext::_('You have entered special ZIP without geo coordinates');
			return $filter;				
		}
		
		//more accuracity in counting lat long mails per degree checked out formula www.ncgia.ucsb.edu/giscc/units/u014/u014.html
		$milesperdegree_lat = 69.172;
		$milesperdegree_lon = cos(deg2rad($latlong['0']))*69.172;
		$degreesdiff_lat = $miles / $milesperdegree_lat;
		$degreesdiff_lon = $miles / $milesperdegree_lon;
		
		
		$lat1 = $latlong['0'] - $degreesdiff_lat;
		$lat2 = $latlong['0'] + $degreesdiff_lat;
		$lon1 = $latlong['1'] - $degreesdiff_lon;
		$lon2 = $latlong['1'] + $degreesdiff_lon;
	 
//		$sql = "SELECT `zip_code` FROM {$this->table} WHERE lat BETWEEN {$lat1} AND {$lat2} AND lon BETWEEN {$lon1} AND {$lon2}";
//	 	$db->setQuery($sql);
	 	
	 	return array("lat1"=>$lat1, "lat2"=>$lat2, "lon1"=>$lon1, "lon2"=>$lon2);
	}
	
	function table_select ($country){
		$this->table = "#__zip_code_$country";
		return;				
	}
}
?>